<template>
    <div>
        <label class="block text-gray-700 text-sm font-bold pb-2" :for="_uid">
            {{ label }}
        </label>
        <textarea
            ref="textarea"
            class="appearance-none block w-full overflow-hidden resize-none bg-gray-200 p-2 pb-3 text-gray-700 border-2 border-gray-400 leading-tight hover:border-purple-600 focus:outline-none focus:border-purple-600 rounded-sm"
            :class="{'border-red-500': error, 'bg-red-200': (!value || typeof value === 'string' && !value.trim()) && required}"
            :id="_uid"
            type="text"
            :value="value"
            @input="updateValue"
            rows="1"
        ></textarea>
        <p class="text-red-500 text-xs italic" v-if="error">{{ error }}</p>
    </div>
</template>

<script>
export default {
    name: 'TwTextarea',
    props: {
        value: {
            required: true
        },
        label: {
            type: String,
            required: true
        },
        error: {
            type: [String, Boolean],
            default: false
        },
        required: {
            type: Boolean,
            default: false
        }
    },
    methods: {
        updateValue() {
            this.$emit('input', this.$refs.textarea.value)
        },
        resizeTextarea (event) {
            event.target.style.height = 'auto'
            event.target.style.height = event.target.scrollHeight + 'px'
        }
    },
    mounted () {
        this.$refs.textarea.addEventListener('input', this.resizeTextarea)

        this.$nextTick(() => {
            if(this.$refs.textarea) {
                this.$refs.textarea.setAttribute('style', 'height:' + this.$refs.textarea.scrollHeight + 'px')
            }
        })
    },
    beforeDestroy () {
        this.$refs.textarea.removeEventListener('input', this.resizeTextarea)
    }
}
</script>
